/********************************************************************************/
/*                                                                              */
/*									OCCUPY2										*/
/*                                                                              */
/********************************************************************************/

#include "el.h"

#define LOAD_SCREEN		1
#define TITLE_SCREEN	2
#define MENU_SCREEN		3
#define MAIN0_SCREEN	5
#define MAIN1_SCREEN	6
#define PAUSE_SCREEN	7
#define FINISH0_SCREEN	8
#define FINISH1_SCREEN	9
#define END_SCREEN		10
#define THEEND_SCREEN	11

void LoadScreen(void);
void TitleScreen(void);
void MenuScreen(void);
void Main0Screen(void);
void Main1Screen(void);
void PauseScreen(void);
void Finish0Screen(void);
void Finish1Screen(void);
void EndScreen(void);

void Init(void);
void LoadMap(void);
BOOL PAINT(int x,int y,int Dcol);
void ShowString2(long x,long y,char* Str,COLORREF color,short size);

DDOBJ BackBMP;
DDOBJ MapBMP[4]; // }bv
DDOBJ CharaBMP;
DDOBJ NumberBMP;
DDOBJ WindowBMP;
DDOBJ LetterBMP;
DDOBJ RealTimeBMP;
DDOBJ PauseBMP;
DDOBJ ScreenBMP;
DDOBJ Screen2BMP;
DDOBJ OccupyBMP;
DDOBJ SpaceBMP;
DDOBJ WinnerBMP;
DDOBJ ReadyBMP;

DSOBJ StartWAV;
DSOBJ SelectWAV;
DSOBJ FreeWAV;
DSOBJ PauseWAV;
DSOBJ HumanWAV;
DSOBJ WalkWAV[2];
DSOBJ FillWAV;
DSOBJ Fill2WAV;
DSOBJ WinWAV;
DSOBJ LoseWAV;

#define MAP_WIDTH	20
#define MAP_HEIGHT	15
#define HUMAN_MAX	10

static int KeyReturn,KeySpace,KeyEscape,KeyUp,KeyDown,KeyRight,KeyLeft;
unsigned char Map[MAP_WIDTH][MAP_HEIGHT][4],choice,difficulty;
char Buff[128],winner,mode,map=0;
int speed,stage,turn,walk,walk_max,turn_max,turn_count,colorbuf[4],lefttime,lefttime3;
enum { HU,CPU1,CPU2,CPU3,CPU4,ENE0,ENE1,ENE2,ENE3,ENE4,ENE5,ENE6,ENE7,ENE8,ENE9 };
char player[4],win_max,win[4],left;
float count = 0,lefttime2,ready;
char VX_DIR[4] = {1,0,-1,0}, VY_DIR[4] = {0,1,0,-1};
enum STATE {THINK,MOVE,STOP};
enum { PLAYING,STAGE_CLEAR,MISS,TURN_OVER,GAME_OVER } GameState;

typedef struct HUMAN {
	int x,y;
	char vx,vy;
	char dir;
	char straight;
	STATE state;
	char think;
	char color;
	BOOL exist;
	char type;
	unsigned char anim;
	char wait;
} HUMAN;

HUMAN human[HUMAN_MAX];

/********************************************************************************/
/*                                                                              */
/*  C֐                                                                  */
/*                                                                              */
/********************************************************************************/

int elMain("OCCUPY")
{
	elWindow(640,480,FALSE);

	// ʃ[v
	elLoop()
	{
		elSetScreen(LOAD_SCREEN,LoadScreen());
		elSetScreen(TITLE_SCREEN,TitleScreen());
		elSetScreen(MENU_SCREEN,MenuScreen());
		elSetScreen(MAIN0_SCREEN,Main0Screen());
		elSetScreen(MAIN1_SCREEN,Main1Screen());
		elSetScreen(PAUSE_SCREEN,PauseScreen());
		elSetScreen(FINISH0_SCREEN,Finish0Screen());
		elSetScreen(FINISH1_SCREEN,Finish1Screen());
		elSetScreen(END_SCREEN,EndScreen());
	}

	elExitMain();
}

/********************************************************************************/
/*                                                                              */
/*  EBhE֐                                                          */
/*                                                                              */
/********************************************************************************/

void elCreate(void)
{
	elDraw::Screen(640,480);

	elCallScreen(LOAD_SCREEN);
}

/********************************************************************************/
/*                                                                              */
/*  L[{[h֐                                                              */
/*                                                                              */
/********************************************************************************/

void elKeyboard(void)
{
	case VK_ESCAPE:
		break;

	elExitKeyboard();
}

/********************************************************************************/
/*                                                                              */
/*  Cxg֐                                                                */
/*                                                                              */
/********************************************************************************/

long elEvent(void)
{
	elExitEvent();
}

/********************************************************************************/
/*                                                                              */
/*    [h                                                                */
/*                                                                              */
/********************************************************************************/

void LoadScreen(void)
{
	elDraw::Clear();

	ShowString2((640-6*11)/2,(480-12)/2,"NOW LOADING",RGB(255,255,255),12);
	// tbV
	elDraw::Refresh();

	ScreenBMP=elDraw::CreateObject();
	Screen2BMP=elDraw::CreateObject();
	BackBMP=elDraw::LoadObject("BMP\\BACK.BMP");
	SpaceBMP=elDraw::LoadObject("BMP\\SPACE.BMP");
	WinnerBMP=elDraw::LoadObject("BMP\\WINNER.BMP");
	elDraw::SetSpriteLeftTop();
	OccupyBMP=elDraw::LoadObject("BMP\\OCCUPY.BMP");
	elDraw::SetSpriteLeftTop();
	NumberBMP=elDraw::LoadObject("BMP\\NUMBER.BMP");
	elDraw::SetSpriteLeftTop();
	CharaBMP=elDraw::LoadObject("BMP\\CHARA.BMP");
	elDraw::SetSpriteLeftTop();
	LetterBMP=elDraw::LoadObject("BMP\\LETTER.BMP");
	elDraw::SetSpriteLeftTop();
	RealTimeBMP=elDraw::LoadObject("BMP\\REALTIME.BMP");
	elDraw::SetSpriteLeftTop();
	PauseBMP=elDraw::LoadObject("BMP\\PAUSE.BMP");
	MapBMP[0]=elDraw::LoadObject("BMP\\MAP.BMP");
	MapBMP[1]=elDraw::LoadObject("BMP\\MAP2.BMP");
	MapBMP[2]=elDraw::LoadObject("BMP\\MAP3.BMP");
	MapBMP[3]=elDraw::LoadObject("BMP\\MAP4.BMP");
	WindowBMP=elDraw::LoadObject("BMP\\WINDOW.BMP");
	ReadyBMP=elDraw::LoadObject("BMP\\READY.BMP");

	StartWAV=elSound::LoadObject("SOUND\\START.WAV");
	SelectWAV=elSound::LoadObject("SOUND\\SELECT.WAV");
	FreeWAV=elSound::LoadObject("SOUND\\FREE.WAV");
	PauseWAV=elSound::LoadObject("SOUND\\PAUSE.WAV");
	HumanWAV=elSound::LoadObject("SOUND\\HUMAN.WAV");
	WalkWAV[0]=elSound::LoadObject("SOUND\\WALK.WAV");
	WalkWAV[1]=elSound::LoadObject("SOUND\\WALK2.WAV");
	FillWAV=elSound::LoadObject("SOUND\\FILL.WAV");
	Fill2WAV=elSound::LoadObject("SOUND\\FILL2.WAV");
	WinWAV=elSound::LoadObject("SOUND\\WIN.WAV");
	LoseWAV=elSound::LoadObject("SOUND\\LOSE.WAV");

	speed = 4;
	mode = 0;
	stage = 1;
	lefttime3 = 60;

	elCallScreen(TITLE_SCREEN);
}

/********************************************************************************/
/*                                                                              */
/*  ^Cg                                                                */
/*                                                                              */
/********************************************************************************/

void TitleScreen(void)
{
	int i,j,x,y;
	static float Wy;
	static float WaveSize;

	if (elChangeScreen())
	{
		elMusic::Play("MUSIC\\TITLE.MID");// BGM̍Đ
		Init();
		player[0] = HU;
		player[1] = CPU2;
		player[2] = CPU3;
		player[3] = CPU4;
		difficulty = 1;
		win_max = 3;
		turn_max = 25;
		for ( i = 0; i < 4; i++ ) win[i] = 0;
		left = 3;
	}
	// ^Cgwi̕`
	for (y=0;y<4*100+80;y++)
	{
		j=y%100+(int)Wy;

		if (j>100-1) j-=100;

		for (i=0;i<7;i++)
		{
			x=ROUND_X(y+(int)WaveSize,30,0);

			elDraw::Layer(x+i*100-30,y,BackBMP,0,j,100,j+1);
		}
	}

	// EF[u
	WaveSize+=FrameTime*F(30);

	if (WaveSize>=F(360)) WaveSize-=F(360);

	// XN[
	Wy+=FrameTime*F(3);

	if (Wy>=F(100)) Wy-=F(100);

	elDraw::Layer((640-412)/2,100,OccupyBMP,0,0,412,114);
	
	if ( Blink ) elDraw::Layer((640-300)/2,300,SpaceBMP,0,0,300,40);

	// tbV
	elDraw::Refresh();

	elSystem::GetKey(VK_ESCAPE,&KeyEscape);
	elSystem::GetKey(VK_RETURN,&KeyReturn);
	elSystem::GetKey(VK_SPACE,&KeySpace);

	if ( KeySpace==PUSH_KEY || KeyReturn==PUSH_KEY )
	{
		elSound::Play(StartWAV);
		elFadeType(FADE_SLIDE_LEFTRIGHT,20);
		elFadeScreen(MENU_SCREEN);
	}
	if ( KeyEscape==PUSH_KEY )
	{
		elDraw::Exit();
	}
}

/********************************************************************************/
/*                                                                              */
/*  j[																*/
/*                                                                              */
/********************************************************************************/

void MenuScreen(void)
{
	static char state;
	int i,j,x,y;

	if (elChangeScreen())
	{
		state = 0;
		choice = 0;
		elDraw::Clear();
		for ( x = 0; x < 10; x++ )
		{
			for ( y = 0; y < 10; y++ )
			{
				i = rand()%9;
				elDraw::BrightLayer(x*32,y*32,0.5f,MapBMP[map],32*i,0,32*i+32,32);
			}
		}
		elDraw::SpriteScreen(ScreenBMP,0,0,320,320);
	}

	elDraw::TileLayer(16.0f,16.0f,ScreenBMP,0,0,320,320);

	if ( state==0 )
	{
		elDraw::Layer((640-360)/2,2*480/5-30,LetterBMP,
			0,(choice==0)?60:480,360,(choice==0)?120:540);
		elDraw::Layer((640-500)/2,3*480/5-30,RealTimeBMP,
				0,(choice==1)?0:60,500,(choice==1)?60:120);
	}
	else if ( state==1 )
	{
		switch ( difficulty )
		{
		case 0:
			elDraw::Layer((640-240)/2,480/5-30,LetterBMP,
				0,(choice==0)?0:420,240,(choice==0)?60:480);
			break;
		case 1:
			elDraw::Layer((640-360)/2,480/5-30,LetterBMP,
				0,(choice==0)?60:480,360,(choice==0)?120:540);
			break;
		case 2:
			elDraw::Layer((640-240)/2,480/5-30,LetterBMP,
				0,(choice==0)?120:540,240,(choice==0)?180:600);
			break;
		}

		elDraw::Layer((640-300)/2,2*480/5-30,LetterBMP,
			180,(choice==1)?240:660,360,(choice==1)?300:720);
		sprintf(Buff,"%1d",win_max);
		j=Buff[0]-'0';
		elDraw::Layer((640-300)/2+60*4,2*480/5-32,NumberBMP,
			j*64,(choice==1)?0:64,j*64+64,(choice==1)?64:128);

		elDraw::Layer((640-480)/2,3*480/5-30,LetterBMP,
			0,(choice==2)?360:780,300,(choice==2)?420:840);
		sprintf(Buff,"%02d",speed);
		for (i=0;i<2;i++)
		{
			j=Buff[i]-'0';
			elDraw::Layer((640-480)/2+60*6+i*58,3*480/5-32,NumberBMP,
			j*64,(choice==2)?0:64,j*64+64,(choice==2)?64:128);
		}

		if ( mode==1 )
		{
			elDraw::Layer((640-420)/2,4*480/5-30,LetterBMP,
				0,(choice==3)?840:900,232,(choice==3)?900:960);
			sprintf(Buff,"%02d",lefttime3);
			for (i=0;i<2;i++)
			{
				j=Buff[i]-'0';
				elDraw::Layer((640-420)/2+60*5+i*58,4*480/5-32,NumberBMP,
				j*64,(choice==3)?0:64,j*64+64,(choice==3)?64:128);
			}
		}
		else
		{
			elDraw::Layer((640-420)/2,4*480/5-30,LetterBMP,
				0,(choice==3)?300:720,240,(choice==3)?360:780);
			sprintf(Buff,"%02d",turn_max);
			for (i=0;i<2;i++)
			{
				j=Buff[i]-'0';
				elDraw::Layer((640-420)/2+60*5+i*58,4*480/5-32,NumberBMP,
				j*64,(choice==3)?0:64,j*64+64,(choice==3)?64:128);
			}
		}
	}
	else
	{
		for ( i = 0; i < 4; i++ )
		{
			elDraw::Layer(180,(i+1)*480/5-30,CharaBMP,40,i*60,80,i*60+60);
			if ( choice==i ) 
				elDraw::Layer(250,(i+1)*480/5-30,LetterBMP,
				0,(player[i]==HU)?180:240,(player[i]==HU)?300:180,(player[i]==HU)?240:300);
			else
				elDraw::Layer(250,(i+1)*480/5-30,LetterBMP,
				0,(player[i]==HU)?600:660,(player[i]==HU)?300:180,(player[i]==HU)?660:720);
		}
	}
	// tbV
	elDraw::Refresh();

	elSystem::GetKey(VK_RETURN,&KeyReturn);
	elSystem::GetKey(VK_SPACE,&KeySpace);
	elSystem::GetKey(VK_UP,&KeyUp);
	elSystem::GetKey(VK_DOWN,&KeyDown);
	elSystem::GetKey(VK_RIGHT,&KeyRight);
	elSystem::GetKey(VK_LEFT,&KeyLeft);
	elSystem::GetKey(VK_ESCAPE,&KeyEscape);

	if ( KeyLeft==PUSH_KEY )
	{
		if ( state == 1 )
		{
			switch ( choice )
			{
			case 0:
				if ( difficulty > 0 )
				{
					difficulty--;
					elSound::Play(SelectWAV);
				}
				break;
			case 1:
				if ( win_max > 1 )
				{
					win_max--;
					elSound::Play(SelectWAV);
				}
				break;
			case 2:
				if ( speed == 4 )
				{
					speed = 2;
					elSound::Play(SelectWAV);
				}
				else if ( speed == 8 )
				{
					speed = 4;
					elSound::Play(SelectWAV);
				}
				else if ( speed == 16 )
				{
					speed = 8;
					elSound::Play(SelectWAV);
				}
				else if ( speed == 32 )
				{
					speed = 16;
					elSound::Play(SelectWAV);
				}
				break;
			}
		}
		else if ( state == 2 )
		{
			if ( player[choice] != HU )
			{
				player[choice] = HU;
				elSound::Play(SelectWAV);
			}
		}
	}
	if ( KeyRight==PUSH_KEY )
	{
		if ( state == 1 )
		{
			switch ( choice )
			{
			case 0:
				if ( difficulty < 2 )
				{
					difficulty++;
					elSound::Play(SelectWAV);
				}
				break;
			case 1:
				if ( win_max < 9 )
				{
					win_max++;
					elSound::Play(SelectWAV);
				}
				break;
			case 2:
				if ( speed == 2 )
				{
					speed = 4;
					elSound::Play(SelectWAV);
				}
				else if ( speed == 4 )
				{
					speed = 8;
					elSound::Play(SelectWAV);
				}
				else if ( speed == 8 )
				{
					speed = 16;
					elSound::Play(SelectWAV);
				}
				else if ( speed == 16 )
				{
					speed = 32;
					elSound::Play(SelectWAV);
				}
				break;
			}
		}
		else if ( state == 2 )
		{
			if ( player[choice] == HU )
			{
				player[choice] = choice + CPU1;
				elSound::Play(SelectWAV);
			}
		}
	}
	if ( state==1 )
	{
		switch ( mode )
		{
		case 1:
			if ( KeyLeft==HOLD_KEY && choice==3 && lefttime3 > 10 )
			{
				elSound::Play(SelectWAV);
				lefttime3--;
			}
			if ( KeyRight==HOLD_KEY && choice == 3 && lefttime3 < 99 )
			{
				elSound::Play(SelectWAV);
				lefttime3++;
			}
			break;
		default:
			if ( KeyLeft==HOLD_KEY && choice==3 && turn_max > 1 )
			{
				elSound::Play(SelectWAV);
				turn_max--;
			}
			if ( KeyRight==HOLD_KEY && choice == 3 && turn_max < 99 )
			{
				elSound::Play(SelectWAV);
				turn_max++;
			}
		}
	}
	if ( KeyUp==PUSH_KEY && choice > 0 )
	{
		elSound::Play(SelectWAV);
		choice--;
	}
	if ( KeyDown==PUSH_KEY )
	{
		if ( state == 0 )
		{
			if ( choice < 1 )
			{
				elSound::Play(SelectWAV);
				choice++;
			}
		}
		else if ( state == 1 )
		{
			if ( mode==1 )
			{
				if ( choice < 3 )
				{
					elSound::Play(SelectWAV);
					choice++;
				}
			}
			else
			{
				if ( choice < 3 )
				{
					elSound::Play(SelectWAV);
					choice++;
				}
			}
		}
		else if ( choice < 3 )
		{
			elSound::Play(SelectWAV);
			choice++;
		}
	}
	if ( KeySpace==PUSH_KEY || KeyReturn==PUSH_KEY )
	{
		elSound::Play(StartWAV);
		if ( ++state == 1 )
		{
			mode = choice;
		}
		else if ( state == 2 )
		{
			if ( mode == 1 )
			{
				elMusic::Play("MUSIC\\MAIN.MID");// BGM̍Đ
				Init();
				elFadeType(FADE_SLIDE_LEFTRIGHT,20);
				elFadeScreen(MAIN0_SCREEN);
			}
		}
		else if ( state >= 3 )
		{
			elMusic::Play("MUSIC\\MAIN.MID");// BGM̍Đ
			Init();
			elFadeType(FADE_SLIDE_LEFTRIGHT,20);
			elFadeScreen(MAIN1_SCREEN);
		}
		choice = 0;
	}
	if ( KeyEscape==PUSH_KEY )
	{
		elSound::Play(FreeWAV);
		choice = 0;
		if ( state==0 )
		{
			elFadeType(FADE_SLIDE_LEFTRIGHT,20);
			elFadeScreen(TITLE_SCREEN);
		}
		else state--;
	}
}

/********************************************************************************/
/*                                                                              */
/*  C0                                                                 */
/*                                                                              */
/********************************************************************************/

void Main0Screen(void)
{
	int i,x,y;

	if (elChangeScreen())
	{
		count = 0;
		choice = 0;
		human[0].state = MOVE;
		player[0] = HU;
		player[1] = CPU2;
		player[2] = CPU3;
		player[3] = CPU4;
	}

	for ( x = 0; x < MAP_WIDTH; x++ )
	{
		for ( y = 0; y < MAP_HEIGHT; y++ )
		{
			elDraw::DirectLayer(x*32,y*32,MapBMP[map],
				32*Map[x][y][1],32*Map[x][y][0],32*Map[x][y][1]+32,32*Map[x][y][0]+32);
		}
	}


	for ( i = 0; i < 4; i++ )
	{
		if ( (count+=FrameTime) < 0.3 )
		{
			human[i].anim = 0;
		}
		else 
		{
			human[i].anim = 160;
			if ( count >= 0.6 ) count = 0;
		}
		elDraw::Layer(human[i].x-4,human[i].y-28,CharaBMP,
		human[i].dir*40+human[i].anim,i*60,human[i].dir*40+40+human[i].anim,i*60+60);
	}

	if ( (ready+=FrameTime) < 1.5f )
	{
		elDraw::StretchLayer(int(640-ready*300)/2,int(480-ready*60)/2,
			ReadyBMP,0,0,300,60,int(ready*300),int(ready*60));
		// tbV
		elDraw::Refresh();
		return;
	}
	else if (ready < 3.0f )
	{
		elDraw::StretchLayer(int(640-(ready-1.5f)*150)/2,int(480-(ready-1.5f)*60)/2,ReadyBMP,
			300,0,450,60,int((ready-1.5f)*150),int((ready-1.5f)*60));
		// tbV
		elDraw::Refresh();
		return;
	}

	if ( (lefttime2 += FrameTime) >= 1 )
	{
		lefttime--;
		lefttime2 = 0;
	}

	if ( human[0].x < 32*10 )
	{
		if ( human[0].y < 32*8 )
		{
			elDraw::Layer(640-64-32-64+10,480-64-32,NumberBMP,(lefttime/10)*64,0,(lefttime/10)*64+64,64);
			elDraw::Layer(640-64-32,480-64-32,NumberBMP,(lefttime%10)*64,0,(lefttime%10)*64+64,64);
		}
		else
		{
			elDraw::Layer(640-64-32-64+10,32,NumberBMP,(lefttime/10)*64,0,(lefttime/10)*64+64,64);
			elDraw::Layer(640-64-32,32,NumberBMP,(lefttime%10)*64,0,(lefttime%10)*64+64,64);
		}
	}
	else
	{
		if ( human[0].y < 32*8 )
		{
			elDraw::Layer(32,480-64-32,NumberBMP,(lefttime/10)*64,0,(lefttime/10)*64+64,64);
			elDraw::Layer(32+64-10,480-64-32,NumberBMP,(lefttime%10)*64,0,(lefttime%10)*64+64,64);
		}
		else
		{
			elDraw::Layer(32,32,NumberBMP,(lefttime/10)*64,0,(lefttime/10)*64+64,64);
			elDraw::Layer(32+64-10,32,NumberBMP,(lefttime%10)*64,0,(lefttime%10)*64+64,64);
		}
	}

	// tbV
	elDraw::Refresh();

	elSystem::GetKey(VK_RETURN,&KeyReturn);
	elSystem::GetKey(VK_SPACE,&KeySpace);
	elSystem::GetKey(VK_UP,&KeyUp);
	elSystem::GetKey(VK_DOWN,&KeyDown);
	elSystem::GetKey(VK_RIGHT,&KeyRight);
	elSystem::GetKey(VK_LEFT,&KeyLeft);
	elSystem::GetKey(VK_ESCAPE,&KeyEscape);

	for ( i = 0; i < 4; i++ )
	{
	  switch ( player[i] )
	  {
	  case HU:
		switch ( human[0].state )
		{
		case MOVE:
			human[0].x += human[0].vx;
			human[0].y += human[0].vy;

			if ( human[0].vx || human[0].vy )
			{
				if ( !(human[0].x % 32) && !(human[0].y % 32) )
				{
					x = human[0].x/32;
					y = human[0].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != 1 )
					{
						elSound::Play(WalkWAV[1]);
						human[0].wait = (difficulty==0)?1:2;
					}
					else
					{
						elSound::Play(WalkWAV[0]);
						human[0].wait = 1;
					}
					Map[x][y][0] = 1;
					human[0].vx = 0;
					human[0].vy = 0;
					if ( PAINT(x-1,y-1,1) || PAINT(x,y-1,1)
					|| PAINT(x+1,y-1,1) || PAINT(x-1,y,1)
					|| PAINT(x+1,y,1) || PAINT(x-1,y+1,1)
					|| PAINT(x,y+1,1) || PAINT(x+1,y+1,1) )
					{
						elSound::Play(Fill2WAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
					}
				}
			}
			else if ( KeyUp==HOLD_KEY && human[0].y > 0 )
			{
				human[0].vy = -speed/human[0].wait;
				human[0].dir = 3;
			}
			else if ( KeyDown==HOLD_KEY && human[0].y < (MAP_HEIGHT-1)*32 )
			{
				human[0].vy = speed/human[0].wait;
				human[0].dir = 1;
			}
			else if ( KeyRight==HOLD_KEY && human[0].x < (MAP_WIDTH-1)*32 )
			{
				human[0].vx = speed/human[0].wait;
				human[0].dir = 0;
			}
			else if ( KeyLeft==HOLD_KEY && human[0].x > 0 )
			{
				human[0].vx = -speed/human[0].wait;
				human[0].dir = 2;
			}
			break;
		}
		break;

	  case CPU2:
		switch ( human[1].state )
		{
		case THINK:
			switch ( human[1].think )
			{
			case 0:
				human[1].dir = 0;
				if ( human[1].x == 32*(MAP_WIDTH-1) )
				{
					human[1].dir = 3;
					human[1].think = 1;
				}
				break;
			case 1:
				if ( human[1].y == 0 )
				{
					human[1].dir = 2;
					human[1].think = 2;
				}
				break;
			case 2:
				if ( human[1].x == 32*13 )
				{
					human[1].dir = 1;
					human[1].think = 3;
				}
				break;
			case 3:
				if ( human[1].y == 32*3 )
				{
					human[1].dir = 2;
					human[1].think = 4;
				}
				break;
			case 4:
				if ( human[1].x == 0 )
				{
					human[1].dir = 3;
					human[1].think = 5;
				}
				break;
			case 5:
				if ( human[1].y == 0 )
				{
					human[1].dir = 0;
					human[1].think = 6;
				}
				break;
			case 6:
				if ( human[1].x == 32*12 )
				{
					human[1].dir = 1;
					human[1].think = 7;
				}
				break;
			case 7:
				if ( human[1].y == 32*(MAP_HEIGHT-1) )
				{
					human[1].dir = 0;
					human[1].think = 8;
				}
				break;
			case 8:
				if ( human[1].x == 32*(MAP_WIDTH-1) )
				{
					human[1].dir = 3;
					human[1].think = 9;
				}
				break;
			case 9:
				if ( human[1].y == 32*(MAP_HEIGHT-5) )
				{
					human[1].dir = 2;
					human[1].think = 10;
				}
				break;
			case 10:
				if ( human[1].x == 0 )
				{
					human[1].dir = 1;
					human[1].think = 11;
				}
				break;
			case 11:
				if ( human[1].y == 32*(MAP_HEIGHT-1) )
				{
					human[1].dir = 0;
					human[1].think = 12;
				}
				break;
			case 12:
				if ( human[1].x == 32*10 )
				{
					human[1].dir = 3;
					human[1].think = 13;
				}
				break;
			case 13:
				if ( human[1].y == 32*4 )
				{
					human[1].dir = 0;
					human[1].think = 0;
				}
				break;
			}
			human[1].vx = VX_DIR[human[1].dir]*speed/human[1].wait;
			human[1].vy = VY_DIR[human[1].dir]*speed/human[1].wait;
			human[1].state = MOVE;
			break;

		case MOVE:
			human[1].x += human[1].vx;
			human[1].y += human[1].vy;

			if ( human[1].vx || human[1].vy )
			{
				if ( !(human[1].x % 32) && !(human[1].y % 32) )
				{
					x = human[1].x/32;
					y = human[1].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != 1+1 )
					{
						human[1].wait = (difficulty==2)?1:2;
						elSound::Play(WalkWAV[1]);
					}
					else
					{
						human[1].wait = 1;
						elSound::Play(WalkWAV[0]);
					}
					Map[x][y][0] = 1+1;
					human[1].vx = 0;
					human[1].vy = 0;
					if ( PAINT(x-1,y-1,1+1) || PAINT(x,y-1,1+1)
					|| PAINT(x+1,y-1,1+1) || PAINT(x-1,y,1+1)
					|| PAINT(x+1,y,1+1) || PAINT(x-1,y+1,1+1)
					|| PAINT(x,y+1,1+1) || PAINT(x+1,y+1,1+1) )
					{
						elSound::Play(FillWAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
					}
					human[1].state = THINK;
				}
			}
			break;
		}
		break;

	  case CPU3:
		switch ( human[2].state )
		{
		case THINK:
			switch ( human[2].think )
			{
			case 0:
				human[2].dir = 1;
				if ( human[2].y == 32*(MAP_HEIGHT-1) )
				{
					human[2].dir = 0;
					human[2].think = 1;
				}
				break;
			case 1:
				if ( human[2].x == 12*32 )
				{
					human[2].dir = 3;
					human[2].think = 2;
				}
				break;
			case 2:
				if ( human[2].y == 32*9 )
				{
					human[2].dir = 2;
					human[2].think = 3;
				}
				break;
			case 3:
				if ( human[2].x == 0 )
				{
					human[2].dir = 3;
					human[2].think = 4;
				}
				break;
			case 4:
				if ( human[2].y == 32*5 )
				{
					human[2].dir = 0;
					human[2].think = 5;
				}
				break;
			case 5:
				if ( human[2].x == 32*6 )
				{
					human[2].dir = 1;
					human[2].think = 6;
				}
				break;
			case 6:
				if ( human[2].y == 32*8 )
				{
					human[2].dir = 0;
					human[2].think = 7;
				}
				break;
			case 7:
				if ( human[2].x == 32*(MAP_WIDTH-1) )
				{
					human[2].dir = 3;
					human[2].think = 8;
				}
				break;
			case 8:
				if ( human[2].y == 5*32 )
				{
					human[2].dir = 2;
					human[2].think = 9;
				}
				break;
			case 9:
				if ( human[2].x == 12*32 )
				{
					human[2].dir = 1;
					human[2].think = 10;
				}
				break;
			case 10:
				if ( human[2].y == 32*7 )
				{
					human[2].dir = 3;
					human[2].think = 11;
				}
				break;
			case 11:
				if ( human[2].y == 0 )
				{
					human[2].dir = 2;
					human[2].think = 12;
				}
				break;
			case 12:
				if ( human[2].x == 32*6 )
				{
					human[2].dir = 1;
					human[2].think = 13;
				}
				break;
			case 13:
				if ( human[2].y == 32*5 )
				{
					human[2].dir = 0;
					human[2].think = 14;
				}
				break;
			case 14:
				if ( human[2].x == 32*11 )
				{
					human[2].dir = 2;
					human[2].think = 15;
				}
				break;
			case 15:
				if ( human[2].x == 32*6 )
				{
					human[2].dir = 1;
					human[2].think = 0;
				}
				break;
			}
			human[2].vx = VX_DIR[human[2].dir]*speed/human[2].wait;
			human[2].vy = VY_DIR[human[2].dir]*speed/human[2].wait;
			human[2].state = MOVE;
			break;

		case MOVE:
			human[2].x += human[2].vx;
			human[2].y += human[2].vy;

			if ( human[2].vx || human[2].vy )
			{
				if ( !(human[2].x % 32) && !(human[2].y % 32) )
				{
					x = human[2].x/32;
					y = human[2].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != 2+1 )
					{
						human[2].wait = (difficulty==2)?1:2;
						elSound::Play(WalkWAV[1]);
					}
					else
					{
						human[2].wait = 1;
						elSound::Play(WalkWAV[0]);
					}
					Map[x][y][0] = 2+1;
					human[2].vx = 0;
					human[2].vy = 0;
					if ( PAINT(x-1,y-1,2+1) || PAINT(x,y-1,2+1)
					|| PAINT(x+1,y-1,2+1) || PAINT(x-1,y,2+1)
					|| PAINT(x+1,y,2+1) || PAINT(x-1,y+1,2+1)
					|| PAINT(x,y+1,2+1) || PAINT(x+1,y+1,2+1) )
					{
						elSound::Play(FillWAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
					}
					human[2].state = THINK;
				}
			}
			break;
		}
		break;

	  default:
		switch ( human[3].state )
		{
		case THINK:
			if ( --human[3].straight<=0 )
			{
				human[3].dir = (human[3].dir+3) % 4;
				human[3].straight = 5+rand()%5;
				if ( ++human[3].think > 4 )
				{
					human[3].dir = rand()%4;  
					human[3].think = 0;
				}
			}
			if ( human[3].x == 0 )
			{
				if ( human[3].dir == 2 )
				{
					human[3].dir = 1;
					human[3].straight = 5+rand()%5;
				}
			}
			if ( human[3].x == 32*(MAP_WIDTH-1) )
			{
				if ( human[3].dir == 0 )
				{
					human[3].dir = 3;
					human[3].straight = 5+rand()%5;
				}
			}
			if ( human[3].y == 0 )
			{
				if ( human[3].dir == 3 )
				{
					human[3].dir = 2;
					human[3].straight = 5+rand()%5;
				}
				if ( human[3].x == 0 )
				{
					human[3].dir = 1;
					human[3].straight = 5+rand()%5;
				}
			}
			if ( human[3].y == 32*(MAP_HEIGHT-1) )
			{
				if ( human[3].dir == 1 )
				{
					human[3].dir = 0;
					human[3].straight = 5+rand()%5;
				}
				if ( human[3].x == 32*(MAP_WIDTH-1) )
				{
					human[3].dir = 3;
					human[3].straight = 5+rand()%5;
				}
			}
			human[3].vx = VX_DIR[human[3].dir]*speed/human[3].wait;
			human[3].vy = VY_DIR[human[3].dir]*speed/human[3].wait;
			human[3].state = MOVE;
			break;

		case MOVE:
			human[3].x += human[3].vx;
			human[3].y += human[3].vy;

			if ( human[3].vx || human[3].vy )
			{
				if ( !(human[3].x % 32) && !(human[3].y % 32) )
				{
					x = human[3].x/32;
					y = human[3].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != 3+1 )
					{
						human[3].wait = (difficulty==2)?1:2;
						elSound::Play(WalkWAV[1]);
					}
					else
					{
						human[3].wait = 1;
						elSound::Play(WalkWAV[0]);
					}
					Map[x][y][0] = 3+1;
					human[3].vx = 0;
					human[3].vy = 0;
					if ( PAINT(x-1,y-1,3+1) || PAINT(x,y-1,3+1)
					|| PAINT(x+1,y-1,3+1) || PAINT(x-1,y,3+1)
					|| PAINT(x+1,y,3+1) || PAINT(x-1,y+1,3+1)
					|| PAINT(x,y+1,3+1) || PAINT(x+1,y+1,3+1) )
					{
						elSound::Play(FillWAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
						human[3].straight = 5+rand()%5;
						human[3].dir = rand()%4;
					}
					human[3].state = THINK;
				}
			}
			break;
		}
		break;
	  }
	}

	switch ( mode )
	{
	case 1:
		if ( lefttime <= 0 )
		{
			elFadeType(FADE_SLIDE_LEFTRIGHT,20);
			elFadeScreen(FINISH0_SCREEN);
		}
		break;
	}

	// [ESCAPE]L[ꂽꍇA|[Y
	if ( KeyEscape==HOLD_KEY )
	{
		elSound::Play(PauseWAV);
		elCallScreen(PAUSE_SCREEN);
	}
}

/********************************************************************************/
/*                                                                              */
/*  C1                                                                 */
/*                                                                              */
/********************************************************************************/

void Main1Screen(void)
{
	int i,x,y;
	static int pre_x,pre_y;

	if (elChangeScreen())
	{
		count = 0;
		choice = 0;
	}

	for ( x = 0; x < MAP_WIDTH; x++ )
	{
		for ( y = 0; y < MAP_HEIGHT; y++ )
		{
			elDraw::DirectLayer(x*32,y*32,MapBMP[map],
				32*Map[x][y][1],32*Map[x][y][0],32*Map[x][y][1]+32,32*Map[x][y][0]+32);
		}
	}

	if ( (count+=FrameTime) < 0.3 ) human[turn].anim = 0;
	else 
	{
		human[turn].anim = 160;
		if ( count >= 0.6 ) count = 0;
	}

	for ( i = 0; i < 4; i++ )
		elDraw::Layer(human[i].x-4,human[i].y-28,CharaBMP,
		human[i].dir*40+human[i].anim,i*60,human[i].dir*40+40+human[i].anim,i*60+60);

	if ( (ready+=FrameTime) < 1.5f )
	{
		elDraw::StretchLayer(int(640-ready*300)/2,int(480-ready*60)/2,
			ReadyBMP,0,0,300,60,int(ready*300),int(ready*60));
		// tbV
		elDraw::Refresh();
		return;
	}
	else if (ready < 3.0f )
	{
		elDraw::StretchLayer(int(640-(ready-1.5f)*150)/2,int(480-(ready-1.5f)*60)/2,ReadyBMP,
			300,0,450,60,int((ready-1.5f)*150),int((ready-1.5f)*60));
		// tbV
		elDraw::Refresh();
		return;
	}

	if ( walk > 0 )
	{
		if ( human[turn].x < 32*10 )
		{
			if ( human[turn].y < 32*8 )
				elDraw::Layer(640-64-32,480-64-32,NumberBMP,walk*64,0,walk*64+64,64);
			else
				elDraw::Layer(640-64-32,32,NumberBMP,walk*64,0,walk*64+64,64);
		}
		else
		{
			if ( human[turn].y < 32*8 )
				elDraw::Layer(32,480-64-32,NumberBMP,walk*64,0,walk*64+64,64);
			else
				elDraw::Layer(32,32,NumberBMP,walk*64,0,walk*64+64,64);
		}
	}

	if ( walk<=0 && player[turn]==HU )
	{
		if ( human[turn].y < 32*8 )
		{
			elDraw::DirectLayer(32,32*11,WindowBMP,0,0,450,96);
			elDraw::DirectLayer(490,32*11,WindowBMP,0,0,116,96);
			elDraw::DirectLayer(32*19-2,32*11,WindowBMP,450-2,0,450,96);
			ShowString2(32+20,32*11+3*32/3-10,"Ŏ~܂܂H",RGB(255,255,255),20);
			ShowString2(490+29,32*11+3*32/3-10,"́@",
				(choice==0)?RGB(255,255,0):RGB(255,255,255),20);
			ShowString2(490+29,32*11+3*32/3*2-10,"",
				(choice==1)?RGB(255,255,0):RGB(255,255,255),20);
			if ( mode==0 )
				sprintf(Buff,"^[ %02d/%02dA %1d/%1d",
				turn_count/4,turn_max,win[turn],win_max);
			else 
				sprintf(Buff," %1d/%1d",win[turn],win_max);
			ShowString2(32+20,32*11+3*32/3*2-10,Buff,RGB(255,255,255),20);
		}
		else
		{
			elDraw::DirectLayer(32,32,WindowBMP,0,0,450,96);
			elDraw::DirectLayer(490,32,WindowBMP,0,0,116,96);
			elDraw::DirectLayer(32*19-2,32,WindowBMP,450-2,0,450,96);
			ShowString2(32+20,32+3*32/3-10,"Ŏ~܂܂H",RGB(255,255,255),20);
			ShowString2(490+29,32+3*32/3-10,"́@",
				(choice==0)?RGB(255,255,0):RGB(255,255,255),20);
			ShowString2(490+29,32+3*32/3*2-10,"",
				(choice==1)?RGB(255,255,0):RGB(255,255,255),20);
			if ( mode==0 )
				sprintf(Buff,"^[ %02d/%02dA %1d/%1d",
				turn_count/4,turn_max,win[turn],win_max);
			else
				sprintf(Buff," %1d/%1d",win[turn],win_max);
			ShowString2(32+20,32+3*32/3*2-10,Buff,RGB(255,255,255),20);
		}
	}

	// tbV
	elDraw::Refresh();

	elSystem::GetKey(VK_RETURN,&KeyReturn);
	elSystem::GetKey(VK_SPACE,&KeySpace);
	elSystem::GetKey(VK_UP,&KeyUp);
	elSystem::GetKey(VK_DOWN,&KeyDown);
	elSystem::GetKey(VK_RIGHT,&KeyRight);
	elSystem::GetKey(VK_LEFT,&KeyLeft);
	elSystem::GetKey(VK_ESCAPE,&KeyEscape);

	switch ( player[turn] )
	{
	case HU:
		switch ( human[turn].state )
		{
		case THINK:
			for ( x = 0; x < MAP_WIDTH; x++ )
			{
				for ( y = 0; y < MAP_HEIGHT; y++ )
				{
					Map[x][y][3] = Map[x][y][0];
				}
			}
			pre_x = human[turn].x;
			pre_y = human[turn].y;
			human[turn].state = MOVE;
			elSound::Play(HumanWAV);

		case MOVE:
			human[turn].x += human[turn].vx;
			human[turn].y += human[turn].vy;

			if ( human[turn].vx || human[turn].vy )
			{
				if ( !(human[turn].x % 32) && !(human[turn].y % 32) )
				{
					x = human[turn].x/32;
					y = human[turn].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != turn+1 )
					{
						walk-=difficulty;
						elSound::Play(WalkWAV[1]);
					}
					else elSound::Play(WalkWAV[0]);
					Map[x][y][0] = turn+1;
					human[turn].vx = 0;
					human[turn].vy = 0;
					if ( PAINT(x-1,y-1,turn+1) || PAINT(x,y-1,turn+1)
					|| PAINT(x+1,y-1,turn+1) || PAINT(x-1,y,turn+1)
					|| PAINT(x+1,y,turn+1) || PAINT(x-1,y+1,turn+1)
					|| PAINT(x,y+1,turn+1) || PAINT(x+1,y+1,turn+1) )
					{
						elSound::Play(Fill2WAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
					}
					if ( --walk <= 0 )
					{
						human[turn].state = STOP;
						choice = 0;
					}
				}
			}
			else if ( KeyUp==HOLD_KEY && human[turn].y > 0 )
			{
				human[turn].vy = -speed;
				human[turn].dir = 3;
			}
			else if ( KeyDown==HOLD_KEY && human[turn].y < (MAP_HEIGHT-1)*32 )
			{
				human[turn].vy = speed;
				human[turn].dir = 1;
			}
			else if ( KeyRight==HOLD_KEY && human[turn].x < (MAP_WIDTH-1)*32 )
			{
				human[turn].vx = speed;
				human[turn].dir = 0;
			}
			else if ( KeyLeft==HOLD_KEY && human[turn].x > 0 )
			{
				human[turn].vx = -speed;
				human[turn].dir = 2;
			}
			break;

		case STOP:
			if ( KeyUp==PUSH_KEY ) choice = 0;
			if ( KeyDown==PUSH_KEY ) choice = 1;
			if ( KeySpace==PUSH_KEY )
			{
				if ( choice == 0 )
				{
					turn = (turn+1)%4;
					walk = walk_max = Map[human[turn].x/32][human[turn].y/32][1]+1;
					human[turn].state = THINK;
					turn_count++;
				}
				else
				{
					for ( x = 0; x < MAP_WIDTH; x++ )
					{
						for ( y = 0; y < MAP_HEIGHT; y++ )
						{
							Map[x][y][0] = Map[x][y][3];
						}
					}
					human[turn].x = pre_x;
					human[turn].y = pre_y;
					walk = walk_max;
					human[turn].state = MOVE;
				}
			}
		}
		break;

	case CPU1:
		switch ( human[turn].state )
		{
		case THINK:
			if ( --human[turn].straight<=0 )
			{
				human[turn].dir = (human[turn].dir+1) % 4;
				human[turn].straight = 4+rand()%6;
				if ( ++human[turn].think > 4 )
				{
					human[turn].dir = rand()%4;  
					human[turn].think = 0;
				}
			}
			if ( human[turn].x == 0 )
			{
				if ( human[turn].dir == 2 )
				{
					human[turn].dir = 3;
					human[turn].straight = 5+rand()%5;
				}
			}
			if ( human[turn].x == 32*(MAP_WIDTH-1) )
			{
				if ( human[turn].dir == 0 )
				{
					human[turn].dir = 1;
					human[turn].straight = 5+rand()%5;
				}
			}
			if ( human[turn].y == 0 )
			{
				if ( human[turn].dir == 3 )
				{
					human[turn].dir = 0;
					human[turn].straight = 5+rand()%5;
				}
				if ( human[turn].x == 32*(MAP_WIDTH-1) )
				{
					human[turn].dir = 2;
					human[turn].straight = 5+rand()%5;
				}
			}
			if ( human[turn].y == 32*(MAP_HEIGHT-1) )
			{
				if ( human[turn].dir == 1 )
				{
					human[turn].dir = 2;
					human[turn].straight = 5+rand()%5;
				}
				if ( human[turn].x == 0 )
				{
					human[turn].dir = 3;
					human[turn].straight = 5+rand()%5;
				}
			}
			human[turn].vx = VX_DIR[human[turn].dir]*speed;
			human[turn].vy = VY_DIR[human[turn].dir]*speed;
			human[turn].state = MOVE;
			break;

		case MOVE:
			human[turn].x += human[turn].vx;
			human[turn].y += human[turn].vy;

			if ( human[turn].vx || human[turn].vy )
			{
				if ( !(human[turn].x % 32) && !(human[turn].y % 32) )
				{
					x = human[turn].x/32;
					y = human[turn].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != turn+1 )
					{
						walk--;
						elSound::Play(WalkWAV[1]);
					}
					else elSound::Play(WalkWAV[0]);
					Map[x][y][0] = turn+1;
					human[turn].vx = 0;
					human[turn].vy = 0;
					if ( PAINT(x-1,y-1,turn+1) || PAINT(x,y-1,turn+1)
					|| PAINT(x+1,y-1,turn+1) || PAINT(x-1,y,turn+1)
					|| PAINT(x+1,y,turn+1) || PAINT(x-1,y+1,turn+1)
					|| PAINT(x,y+1,turn+1) || PAINT(x+1,y+1,turn+1) )
					{
						elSound::Play(FillWAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
					}
					if ( --walk <= 0 )
					{
						turn = (turn+1)%4;
						walk = walk_max = Map[human[turn].x/32][human[turn].y/32][1]+1;
						turn_count++;
					}
					human[turn].state = THINK;
				}
			}
			break;
		}
		break;

	case CPU2:
		switch ( human[turn].state )
		{
		case THINK:
			switch ( human[turn].think )
			{
			case 0:
				human[turn].dir = 0;
				if ( human[turn].x == 32*(MAP_WIDTH-1) )
				{
					human[turn].dir = 3;
					human[turn].think = 1;
				}
				break;
			case 1:
				if ( human[turn].y == 0 )
				{
					human[turn].dir = 2;
					human[turn].think = 2;
				}
				break;
			case 2:
				if ( human[turn].x == 32*13 )
				{
					human[turn].dir = 1;
					human[turn].think = 3;
				}
				break;
			case 3:
				if ( human[turn].y == 32*3 )
				{
					human[turn].dir = 2;
					human[turn].think = 4;
				}
				break;
			case 4:
				if ( human[turn].x == 0 )
				{
					human[turn].dir = 3;
					human[turn].think = 5;
				}
				break;
			case 5:
				if ( human[turn].y == 0 )
				{
					human[turn].dir = 0;
					human[turn].think = 6;
				}
				break;
			case 6:
				if ( human[turn].x == 32*12 )
				{
					human[turn].dir = 1;
					human[turn].think = 7;
				}
				break;
			case 7:
				if ( human[turn].y == 32*(MAP_HEIGHT-1) )
				{
					human[turn].dir = 0;
					human[turn].think = 8;
				}
				break;
			case 8:
				if ( human[turn].x == 32*(MAP_WIDTH-1) )
				{
					human[turn].dir = 3;
					human[turn].think = 9;
				}
				break;
			case 9:
				if ( human[turn].y == 32*(MAP_HEIGHT-5) )
				{
					human[turn].dir = 2;
					human[turn].think = 10;
				}
				break;
			case 10:
				if ( human[turn].x == 0 )
				{
					human[turn].dir = 1;
					human[turn].think = 11;
				}
				break;
			case 11:
				if ( human[turn].y == 32*(MAP_HEIGHT-1) )
				{
					human[turn].dir = 0;
					human[turn].think = 12;
				}
				break;
			case 12:
				if ( human[turn].x == 32*10 )
				{
					human[turn].dir = 3;
					human[turn].think = 13;
				}
				break;
			case 13:
				if ( human[turn].y == 32*4 )
				{
					human[turn].dir = 0;
					human[turn].think = 0;
				}
				break;
			}
			human[turn].vx = VX_DIR[human[turn].dir]*speed;
			human[turn].vy = VY_DIR[human[turn].dir]*speed;
			human[turn].state = MOVE;
			break;

		case MOVE:
			human[turn].x += human[turn].vx;
			human[turn].y += human[turn].vy;

			if ( human[turn].vx || human[turn].vy )
			{
				if ( !(human[turn].x % 32) && !(human[turn].y % 32) )
				{
					x = human[turn].x/32;
					y = human[turn].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != turn+1 )
					{
						walk--;
						elSound::Play(WalkWAV[1]);
					}
					else elSound::Play(WalkWAV[0]);
					Map[x][y][0] = turn+1;
					human[turn].vx = 0;
					human[turn].vy = 0;
					if ( PAINT(x-1,y-1,turn+1) || PAINT(x,y-1,turn+1)
					|| PAINT(x+1,y-1,turn+1) || PAINT(x-1,y,turn+1)
					|| PAINT(x+1,y,turn+1) || PAINT(x-1,y+1,turn+1)
					|| PAINT(x,y+1,turn+1) || PAINT(x+1,y+1,turn+1) )
					{
						elSound::Play(FillWAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
					}
					if ( --walk <= 0 )
					{
						turn = (turn+1)%4;
						walk = walk_max = Map[human[turn].x/32][human[turn].y/32][1]+1;
						turn_count++;
					}
					human[turn].state = THINK;
				}
			}
			break;
		}
		break;

	case CPU3:
		switch ( human[turn].state )
		{
		case THINK:
			switch ( human[turn].think )
			{
			case 0:
				human[turn].dir = 1;
				if ( human[turn].y == 32*(MAP_HEIGHT-1) )
				{
					human[turn].dir = 0;
					human[turn].think = 1;
				}
				break;
			case 1:
				if ( human[turn].x == 12*32 )
				{
					human[turn].dir = 3;
					human[turn].think = 2;
				}
				break;
			case 2:
				if ( human[turn].y == 32*9 )
				{
					human[turn].dir = 2;
					human[turn].think = 3;
				}
				break;
			case 3:
				if ( human[turn].x == 0 )
				{
					human[turn].dir = 3;
					human[turn].think = 4;
				}
				break;
			case 4:
				if ( human[turn].y == 32*5 )
				{
					human[turn].dir = 0;
					human[turn].think = 5;
				}
				break;
			case 5:
				if ( human[turn].x == 32*6 )
				{
					human[turn].dir = 1;
					human[turn].think = 6;
				}
				break;
			case 6:
				if ( human[turn].y == 32*8 )
				{
					human[turn].dir = 0;
					human[turn].think = 7;
				}
				break;
			case 7:
				if ( human[turn].x == 32*(MAP_WIDTH-1) )
				{
					human[turn].dir = 3;
					human[turn].think = 8;
				}
				break;
			case 8:
				if ( human[turn].y == 5*32 )
				{
					human[turn].dir = 2;
					human[turn].think = 9;
				}
				break;
			case 9:
				if ( human[turn].x == 12*32 )
				{
					human[turn].dir = 1;
					human[turn].think = 10;
				}
				break;
			case 10:
				if ( human[turn].y == 32*7 )
				{
					human[turn].dir = 3;
					human[turn].think = 11;
				}
				break;
			case 11:
				if ( human[turn].y == 0 )
				{
					human[turn].dir = 2;
					human[turn].think = 12;
				}
				break;
			case 12:
				if ( human[turn].x == 32*6 )
				{
					human[turn].dir = 1;
					human[turn].think = 13;
				}
				break;
			case 13:
				if ( human[turn].y == 32*5 )
				{
					human[turn].dir = 0;
					human[turn].think = 14;
				}
				break;
			case 14:
				if ( human[turn].x == 32*11 )
				{
					human[turn].dir = 2;
					human[turn].think = 15;
				}
				break;
			case 15:
				if ( human[turn].x == 32*6 )
				{
					human[turn].dir = 1;
					human[turn].think = 0;
				}
				break;
			}
			human[turn].vx = VX_DIR[human[turn].dir]*speed;
			human[turn].vy = VY_DIR[human[turn].dir]*speed;
			human[turn].state = MOVE;
			break;

		case MOVE:
			human[turn].x += human[turn].vx;
			human[turn].y += human[turn].vy;

			if ( human[turn].vx || human[turn].vy )
			{
				if ( !(human[turn].x % 32) && !(human[turn].y % 32) )
				{
					x = human[turn].x/32;
					y = human[turn].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != turn+1 )
					{
						walk--;
						elSound::Play(WalkWAV[1]);
					}
					else elSound::Play(WalkWAV[0]);
					Map[x][y][0] = turn+1;
					human[turn].vx = 0;
					human[turn].vy = 0;
					if ( PAINT(x-1,y-1,turn+1) || PAINT(x,y-1,turn+1)
					|| PAINT(x+1,y-1,turn+1) || PAINT(x-1,y,turn+1)
					|| PAINT(x+1,y,turn+1) || PAINT(x-1,y+1,turn+1)
					|| PAINT(x,y+1,turn+1) || PAINT(x+1,y+1,turn+1) )
					{
						elSound::Play(FillWAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
					}
					if ( --walk <= 0 )
					{
						turn = (turn+1)%4;
						walk = walk_max = Map[human[turn].x/32][human[turn].y/32][1]+1;
						turn_count++;
					}
					human[turn].state = THINK;
				}
			}
			break;
		}
		break;

	default:
		switch ( human[turn].state )
		{
		case THINK:
			if ( --human[turn].straight<=0 )
			{
				human[turn].dir = (human[turn].dir+3) % 4;
				human[turn].straight = 5+rand()%5;
				if ( ++human[turn].think > 4 )
				{
					human[turn].dir = rand()%4;  
					human[turn].think = 0;
				}
			}
			if ( human[turn].x == 0 )
			{
				if ( human[turn].dir == 2 )
				{
					human[turn].dir = 1;
					human[turn].straight = 5+rand()%5;
				}
			}
			if ( human[turn].x == 32*(MAP_WIDTH-1) )
			{
				if ( human[turn].dir == 0 )
				{
					human[turn].dir = 3;
					human[turn].straight = 5+rand()%5;
				}
			}
			if ( human[turn].y == 0 )
			{
				if ( human[turn].dir == 3 )
				{
					human[turn].dir = 2;
					human[turn].straight = 5+rand()%5;
				}
				if ( human[turn].x == 0 )
				{
					human[turn].dir = 1;
					human[turn].straight = 5+rand()%5;
				}
			}
			if ( human[turn].y == 32*(MAP_HEIGHT-1) )
			{
				if ( human[turn].dir == 1 )
				{
					human[turn].dir = 0;
					human[turn].straight = 5+rand()%5;
				}
				if ( human[turn].x == 32*(MAP_WIDTH-1) )
				{
					human[turn].dir = 3;
					human[turn].straight = 5+rand()%5;
				}
			}
			human[turn].vx = VX_DIR[human[turn].dir]*speed;
			human[turn].vy = VY_DIR[human[turn].dir]*speed;
			human[turn].state = MOVE;
			break;

		case MOVE:
			human[turn].x += human[turn].vx;
			human[turn].y += human[turn].vy;

			if ( human[turn].vx || human[turn].vy )
			{
				if ( !(human[turn].x % 32) && !(human[turn].y % 32) )
				{
					x = human[turn].x/32;
					y = human[turn].y/32;
					if ( Map[x][y][0] != 0 && Map[x][y][0] != turn+1 )
					{
						walk--;
						elSound::Play(WalkWAV[1]);
					}
					else elSound::Play(WalkWAV[0]);
					Map[x][y][0] = turn+1;
					human[turn].vx = 0;
					human[turn].vy = 0;
					if ( PAINT(x-1,y-1,turn+1) || PAINT(x,y-1,turn+1)
					|| PAINT(x+1,y-1,turn+1) || PAINT(x-1,y,turn+1)
					|| PAINT(x+1,y,turn+1) || PAINT(x-1,y+1,turn+1)
					|| PAINT(x,y+1,turn+1) || PAINT(x+1,y+1,turn+1) )
					{
						elSound::Play(FillWAV);
						for ( x = 0; x < MAP_WIDTH; x++ )
						{
							for ( y = 0; y < MAP_HEIGHT; y++ )
							{
								Map[x][y][0] = Map[x][y][2];
							}
						}
						human[turn].straight = 5+rand()%5;
						human[turn].dir = rand()%4;
					}
					if ( --walk <= 0 )
					{
						turn = (turn+1)%4;
						walk = walk_max = Map[human[turn].x/32][human[turn].y/32][1]+1;
						turn_count++;
					}
					human[turn].state = THINK;
				}
			}
			break;
		}
		break;
	}

	switch ( mode )
	{
	case 0:
		if ( turn_count >= 4*turn_max )
		{
			elFadeType(FADE_SLIDE_LEFTRIGHT,20);
			elFadeScreen(FINISH0_SCREEN);
		}
		break;
	case 3:
		colorbuf[0] = 0;
		colorbuf[1] = 0;
		colorbuf[2] = 0;
		colorbuf[3] = 0;
		for ( x = 0; x < MAP_WIDTH; x++ )
		{
			for ( y = 0; y < MAP_HEIGHT; y++ )
			{
				if ( Map[x][y][0] ) colorbuf[Map[x][y][0]-1]++;
			}
		}
		for ( i = 0; i < 4; i++ )
		{
			if ( colorbuf[i] >= 120 )
			{
				elFadeType(FADE_SLIDE_LEFTRIGHT,20);
				elFadeScreen(FINISH1_SCREEN);
			}
		}
		break;
	}

	// [ESCAPE]L[ꂽꍇA|[Y
	if ( KeyEscape==HOLD_KEY && !(human[turn].x%32) && !(human[turn].y%32) )
	{
		elSound::Play(PauseWAV);
		elCallScreen(PAUSE_SCREEN);
	}
}

#define MAXSIZE	1024	/* obt@TCY */
#define MINX 0
#define MINY 0

BOOL PAINT(int x,int y,int Dcol)
{
	struct bufstr {		int	sx;		int	sy;	};
	struct bufstr buffer[MAXSIZE];
	int start_idx,end_idx;
	int LX,RX,UY,DY;
	int i,col,xx,yy;

	if ( x<=0 || y<=0 || x>=MAP_WIDTH-1 || y>=MAP_HEIGHT-1 || Map[x][y][0]==Dcol ) return FALSE;

	for ( xx = 0; xx < MAP_WIDTH; xx++ )
	{
		for ( yy = 0; yy < MAP_HEIGHT; yy++ )
		{
			Map[xx][yy][2] = Map[xx][yy][0];
		}
	}

	start_idx = 0;
	end_idx = 1;
	buffer[start_idx].sx = x;
	buffer[start_idx].sy = y;
	col = Map[x][y][2];
	do {
		LX = buffer[start_idx].sx;
		RX = buffer[start_idx].sx;
		UY = buffer[start_idx].sy;
		DY = buffer[start_idx].sy;
		start_idx++;
		if ( start_idx == MAXSIZE ) start_idx = 0;
		/* ς̃V[hȂ疳 */
		if ( Map[LX][UY][2] == Dcol ) continue;
		/* E̋ET */
		while ( RX < MAP_WIDTH-1 )
		{
			RX++;
			if ( Map[RX][UY][2] == Dcol )
			{
				RX--;
				break;
			}
		}
		if ( RX == MAP_WIDTH-1 ) return FALSE;
		/* ̋ET */
		while ( LX > MINX )
		{
			LX--;
			if ( Map[LX][UY][2] == Dcol )
			{
				LX++;
				break;
			}
		}
		if ( LX == 0 || UY == 0 || UY == MAP_HEIGHT-1 ) return FALSE;
		/* LX-RX̐` */
		for ( i = LX; i <= RX; i++ ) Map[i][UY][2]=Dcol;
		/* ^̃XLC𑖍 */
		if ( --UY >= MINY )
		{
			i = LX;
			while ( i <= RX )
			{
				/* ̈F΂ */
				for ( ; i < RX; i++ )
					if ( Map[i][UY][2] != Dcol ) break;
				if ( Map[i][UY][2] == Dcol ) break;
				/* ̈F΂ */
				for ( ; i <= RX; i++ )
					if ( Map[i][UY][2] == Dcol ) break;
				buffer[end_idx].sx = i - 1;
				buffer[end_idx].sy = UY;
				end_idx++;
				if ( end_idx == MAXSIZE ) end_idx = 0;	/*  ǉ */
			}
		}
		/* ^̃XLC𑖍 */
		if ( ++DY < MAP_HEIGHT )
		{	
			i = LX;
			while ( i <= RX )
			{
				/* ̈F΂ */
				for ( ; i < RX; i++ )
					if ( Map[i][DY][2] != Dcol ) break;
				if ( Map[i][DY][2] == Dcol ) break;
				/* ̈F΂ */
				for ( ; i <= RX; i++ )
					if ( Map[i][DY][2] == Dcol ) break;
				buffer[end_idx].sx = i - 1;
				buffer[end_idx].sy = DY;
				end_idx++;
				if ( end_idx == MAXSIZE ) end_idx = 0;
			}
		}
	} while ( start_idx != end_idx );

	return TRUE;
}

void Init(void)
{
	int i,x,y;

	count = 0;
	for ( x = 0; x < MAP_WIDTH; x++ )
	{
		for ( y = 0 ; y < MAP_HEIGHT; y++ )
		{
			Map[x][y][0] = 0;
			Map[x][y][1] = rand()%9;
		}
	}
	human[0].x = 32*6;
	human[0].y = 32*4;
	human[1].x = 32*13;
	human[1].y = 32*4;
	human[2].x = 32*6;
	human[2].y = 32*10;
	human[3].x = 32*13;
	human[3].y = 32*10;
	for ( i = 0; i < HUMAN_MAX; i++ )
	{
		human[i].vx = 0;
		human[i].vy = 0;
		human[i].dir = 1;
		human[i].straight = 0;
		human[i].think = 0;
		human[i].state = THINK;
		human[i].exist = FALSE;
		human[i].wait = 1;
	}
	for ( i = 0; i < 4; i++ )
	{
		Map[human[i].x/32][human[i].y/32][0] = i+1;
	}
	turn = rand()%4;
	walk = walk_max = Map[human[turn].x/32][human[turn].y/32][1]+1;
	turn_count = 0;
	GameState = PLAYING;
	lefttime = lefttime3;
	ready = 0;
	map = rand() % 4;
}

/********************************************************************************/
/*                                                                              */
/*  |[Y                                                                  */
/*                                                                              */
/********************************************************************************/

void PauseScreen(void)
{
	int i,j,x,y;
	// ʂ؂芷̏ꍇ
	if (elChangeScreen())
	{
		choice = 0;
		elDraw::Clear();
		for ( x = 0; x < 10; x++ )
		{
			for ( y = 0; y < 10; y++ )
			{
				i = rand()%9;
				elDraw::BrightLayer(x*32,y*32,0.5f,MapBMP[map],32*i,0,32*i+32,32);
			}
		}
		elDraw::SpriteScreen(ScreenBMP,0,0,320,320);
	}

	elDraw::TileLayer(16.0f,16.0f,ScreenBMP,0,0,320,320);

	elDraw::Layer((640-450)/2,1*480/5-30,PauseBMP,0,(choice==0)?0:60,450,(choice==0)?60:120);
	elDraw::Layer((640-180)/2,2*480/5-30,PauseBMP,450,(choice==1)?0:60,630,(choice==1)?60:120);
	elDraw::Layer((640-480)/2,3*480/5-30,LetterBMP,0,360,300,420);
	sprintf(Buff,"%02d",speed);
	for (i=0;i<2;i++)
	{
		j=Buff[i]-'0';
		elDraw::Layer((640-480)/2+60*6+i*58,3*480/5-32,NumberBMP,j*64,0,j*64+64,64);
	}
	if ( mode==1 )
	{
		elDraw::Layer((640-600)/2,4*480/5-30,LetterBMP,0,840,240,900);
		sprintf(Buff,"%02d",lefttime);
		for (i=0;i<2;i++)
		{
			j=Buff[i]-'0';
			elDraw::Layer((640-600)/2+60*5+i*58,4*480/5-32,NumberBMP,j*64,0,j*64+64,64);
		}
		elDraw::Layer((640-600)/2+60*7,4*480/5-30,LetterBMP,240,0,270,60);
		sprintf(Buff,"%02d",lefttime3);
		for (i=0;i<2;i++)
		{
			j=Buff[i]-'0';
			elDraw::Layer((640-600)/2+60*8+i*58,4*480/5-32,NumberBMP,j*64,0,j*64+64,64);
		}
	}
	else
	{
		elDraw::Layer((640-600)/2,4*480/5-30,LetterBMP,0,300,240,360);
		sprintf(Buff,"%02d",turn_count/4);
		for (i=0;i<2;i++)
		{
			j=Buff[i]-'0';
			elDraw::Layer((640-600)/2+60*5+i*58,4*480/5-32,NumberBMP,j*64,0,j*64+64,64);
		}
		elDraw::Layer((640-600)/2+60*7,4*480/5-30,LetterBMP,240,0,270,60);
		sprintf(Buff,"%02d",turn_max);
		for (i=0;i<2;i++)
		{
			j=Buff[i]-'0';
			elDraw::Layer((640-600)/2+60*8+i*58,4*480/5-32,NumberBMP,j*64,0,j*64+64,64);
		}
	}
	// tbV
	elDraw::Refresh();

	elSystem::GetKey(VK_RETURN,&KeyReturn);
	elSystem::GetKey(VK_SPACE,&KeySpace);
	elSystem::GetKey(VK_UP,&KeyUp);
	elSystem::GetKey(VK_DOWN,&KeyDown);
	elSystem::GetKey(VK_RIGHT,&KeyRight);
	elSystem::GetKey(VK_LEFT,&KeyLeft);
	elSystem::GetKey(VK_ESCAPE,&KeyEscape);

	if ( KeyLeft==PUSH_KEY )
	{
		if ( speed == 4 )
		{
			speed = 2;
			elSound::Play(SelectWAV);
		}
		else if ( speed == 8 )
		{
			speed = 4;
			elSound::Play(SelectWAV);
		}
		else if ( speed == 16 )
		{
			speed = 8;
			elSound::Play(SelectWAV);
		}
		else if ( speed == 32 )
		{
			speed = 16;
			elSound::Play(SelectWAV);
		}
	}
	if ( KeyRight==PUSH_KEY )
	{
		if ( speed == 2 )
		{
			speed = 4;
			elSound::Play(SelectWAV);
		}
		else if ( speed == 4 )
		{
			speed = 8;
			elSound::Play(SelectWAV);
		}
		else if ( speed == 8 )
		{
			speed = 16;
			elSound::Play(SelectWAV);
		}
		else if ( speed == 16 )
		{
			speed = 32;
			elSound::Play(SelectWAV);
		}
	}
	if ( KeyUp==PUSH_KEY && choice==1 )
	{
		choice = 0;
		elSound::Play(SelectWAV);
	}
	if ( KeyDown==PUSH_KEY && choice==0 )
	{
		choice = 1;
		elSound::Play(SelectWAV);
	}

	if ( KeySpace==PUSH_KEY || KeyReturn==PUSH_KEY )
	{
		if ( choice==0 )
		{
			if ( mode==1 )
			{
				elCallScreen(MAIN0_SCREEN);
			}
			else
			{
				elCallScreen(MAIN1_SCREEN);
			}
			elSound::Play(StartWAV);
		}
		else 
		{
			elFadeType(FADE_SLIDE_LEFTRIGHT,20);
			elFadeScreen(TITLE_SCREEN);
			elSound::Play(FreeWAV);
		}
	}
}

/********************************************************************************/
/*                                                                              */
/*  tBjbV0                                                           */
/*                                                                              */
/********************************************************************************/

void Finish0Screen(void)
{
	static int score[4],color[4],order,flag;
	int i,j,k,x,y,tmp;
	// ʂ؂芷̏ꍇ
	if (elChangeScreen())
	{
		flag = FALSE;
		elMusic::Play("MUSIC\\RANK.MID");// BGM̍Đ
		elMusic::NoLoop();
		count = 0;
		order = 4;
		for ( i = 0; i < 4; i++ )
		{
			score[i] = 0;
			color[i] = i;
		}
		for ( x = 0; x < MAP_WIDTH; x++ )
		{
			for ( y = 0 ; y < MAP_HEIGHT; y++ )
			{
				if ( Map[x][y][0] ) score[Map[x][y][0]-1] += Map[x][y][1]+1;
			}
		}
		for(j = 0; j < 3; j++)
		{
			for(k = j + 1; k < 4; k++)
			{
				if(score[j] < score[k])
				{
					tmp = score[j];
					score[j] = score[k];
					score[k] = tmp;
					tmp = color[j];
					color[j] = color[k];
					color[k] = tmp;
				}
			}
		}
		win[color[0]]++;
		elDraw::Clear();
		for ( x = 0; x < 10; x++ )
		{
			for ( y = 0; y < 10; y++ )
			{
				i = rand()%9;
				elDraw::BrightLayer(x*32,y*32,0.5f,MapBMP[map],
					32*i,color[0]*32+32,32*i+32,color[0]*32+64);
			}
		}
		elDraw::SpriteScreen(ScreenBMP,0,0,320,320);

		for ( x = 0; x < MAP_WIDTH; x++ )
		{
			for ( y = 0; y < MAP_HEIGHT; y++ )
			{
				elDraw::BrightLayer(x*32,y*32,0.5f,MapBMP[map],
				32*Map[x][y][1],32*Map[x][y][0],32*Map[x][y][1]+32,32*Map[x][y][0]+32);
			}
		}
		elDraw::SpriteScreen(Screen2BMP,0,0,640,480);
	}

	if ( order == 0 )
		elDraw::TileLayer(16.0f,16.0f,ScreenBMP,0,0,320,320);
	else
		elDraw::DirectLayer(0,0,Screen2BMP,0,0,640,480);

	if ( (count += FrameTime) >= 2 )
	{
		count = 0;
		if ( --order < 0 )
		{
			order = 0;
		}
	}
	if ( order==0 )
	{
		if ( !flag )
		{
			flag = TRUE;
			elMusic::Play("MUSIC\\WIN.MID");// BGM̍Đ
			if ( player[color[0]]==HU ) elSound::Play(Fill2WAV);
		}
	}
	if ( order > 0 )
	{
		sprintf(Buff,"%04d",rand()%10000);
		for (k=0;k<4;k++)
		{
			j=Buff[k]-'0';
			elDraw::Layer(320+k*58,order*480/5-32,NumberBMP,j*64,0,j*64+64,64);
		}
	}

	for ( i = order; i < 4; i++ )
	{
		sprintf(Buff,"%1d",win[color[i]]);
		j=Buff[0]-'0';
		elDraw::Layer(120,(i+1)*480/5-32,NumberBMP,j*64,0,j*64+64,64);
		elDraw::Layer(230,(i+1)*480/5-30,CharaBMP,40,color[i]*60,80,color[i]*60+60);
	}
	switch ( order )
	{
	case 0:
		for ( i = 0; i < 4; i++ )
		{
			sprintf(Buff,"%04d",score[color[i]]);
			for (k=0;k<4;k++)
			{
				j=Buff[k]-'0';
				elDraw::Layer(320+k*58,(color[i]+1)*480/5-32,NumberBMP,j*64,0,j*64+64,64);
			}
		}
		break;
	case 1:
		for ( i = 0; i < 4; i++ )
		{
			if ( color[i]==0 ) continue;
			sprintf(Buff,"%04d",score[color[i]]);
			for (k=0;k<4;k++)
			{
				j=Buff[k]-'0';
				elDraw::Layer(320+k*58,(color[i]+1)*480/5-32,NumberBMP,j*64,0,j*64+64,64);
			}
		}
		break;
	case 2:
		for ( i = 0; i < 4; i++ )
		{
			if ( color[i]!=3 && color[i]!=2 ) continue;
			sprintf(Buff,"%04d",score[color[i]]);
			for (k=0;k<4;k++)
			{
				j=Buff[k]-'0';
				elDraw::Layer(320+k*58,(color[i]+1)*480/5-32,NumberBMP,j*64,0,j*64+64,64);
			}
		}
		break;
	case 3:
		for ( i = 0; i < 4; i++ )
		{
			if ( color[i]!=3 ) continue;
			sprintf(Buff,"%04d",score[color[i]]);
			for (k=0;k<4;k++)
			{
				j=Buff[k]-'0';
				elDraw::Layer(320+k*58,(color[i]+1)*480/5-32,NumberBMP,j*64,0,j*64+64,64);
			}
		}
		break;
	}
	// tbV
	elDraw::Refresh();

	elSystem::GetKey(VK_RETURN,&KeyReturn);
	elSystem::GetKey(VK_SPACE,&KeySpace);
	elSystem::GetKey(VK_ESCAPE,&KeyEscape);

	if ( KeySpace==PUSH_KEY || KeyReturn==PUSH_KEY )
	{
		if ( order > 0 )
		{
			order = 0;
			flag = TRUE;
			elMusic::Play("MUSIC\\WIN.MID");// BGM̍Đ
			if ( player[color[0]]==HU ) elSound::Play(Fill2WAV);
		}
		else
		{
			elMusic::Play("MUSIC\\MAIN.MID");// BGM̍Đ
			Init();
			elFadeType(FADE_SLIDE_LEFTRIGHT,20);
			elFadeScreen((mode==1)?MAIN0_SCREEN:MAIN1_SCREEN);
			for ( i = 0; i < 4; i++ )
			{
				if ( win[i] >= win_max )
				{
					winner = i;
					elFadeType(FADE_SLIDE_LEFTRIGHT,20);
					elFadeScreen(END_SCREEN);
					if ( player[i]==HU ) elSound::Play(WinWAV);
					else elSound::Play(LoseWAV);
					break;
				}
			}
		}
	}
}

/********************************************************************************/
/*                                                                              */
/*  tBjbV1                                                           */
/*                                                                              */
/********************************************************************************/

void Finish1Screen(void)
{
	static int color[4];
	int i,j,k,x,y,tmp;
	// ʂ؂芷̏ꍇ
	if (elChangeScreen())
	{
		for ( i = 0; i < 4; i++ )
		{
			color[i] = i;
		}
		for(j = 0; j < 3; j++)
		{
			for(k = j + 1; k < 4; k++)
			{
				if(colorbuf[j] < colorbuf[k])
				{
					tmp = colorbuf[j];
					colorbuf[j] = colorbuf[k];
					colorbuf[k] = tmp;
					tmp = color[j];
					color[j] = color[k];
					color[k] = tmp;
				}
			}
		}
		win[color[0]]++;
		elDraw::Clear();
		for ( x = 0; x < 10; x++ )
		{
			for ( y = 0; y < 10; y++ )
			{
				i = rand()%9;
				elDraw::BrightLayer(x*32,y*32,0.5f,MapBMP[map],
					32*i,color[0]*32+32,32*i+32,color[0]*32+64);
			}
		}
		elDraw::SpriteScreen(ScreenBMP,0,0,320,320);
	}

	elDraw::TileLayer(16.0f,16.0f,ScreenBMP,0,0,320,320);

	for ( i = 0; i < 4; i++ )
	{
		sprintf(Buff,"%1d",win[color[i]]);
		j=Buff[0]-'0';
		elDraw::Layer(120,(i+1)*480/5-32,NumberBMP,j*64,0,j*64+64,64);
		elDraw::Layer(230,(i+1)*480/5-30,CharaBMP,40,color[i]*60,80,color[i]*60+60);
		sprintf(Buff,"%03d",colorbuf[color[i]]);
		for (k=0;k<4;k++)
		{
			j=Buff[k]-'0';
			elDraw::Layer(320+k*58,(color[i]+1)*480/5-32,NumberBMP,j*64,0,j*64+64,64);
		}
	}
	// tbV
	elDraw::Refresh();

	elSystem::GetKey(VK_RETURN,&KeyReturn);
	elSystem::GetKey(VK_SPACE,&KeySpace);
	elSystem::GetKey(VK_ESCAPE,&KeyEscape);

	if ( KeySpace==PUSH_KEY || KeyReturn==PUSH_KEY )
	{
		elMusic::Play("MUSIC\\MAIN.MID");// BGM̍Đ
		Init();
		elFadeType(FADE_SLIDE_LEFTRIGHT,20);
		elFadeScreen(MAIN1_SCREEN);
		for ( i = 0; i < 4; i++ )
		{
			if ( win[i] >= win_max )
			{
				winner = i;
				elFadeType(FADE_SLIDE_LEFTRIGHT,20);
				elFadeScreen(END_SCREEN);
				if ( player[i]==HU ) elSound::Play(WinWAV);
				else elSound::Play(LoseWAV);
				break;
			}
		}
	}
}

/********************************************************************************/
/*                                                                              */
/*  Gh																	*/
/*                                                                              */
/********************************************************************************/

void EndScreen(void)
{
	int i,x,y;
	// ʂ؂芷̏ꍇ
	if (elChangeScreen())
	{
		elMusic::Play("MUSIC\\ENDING.MID");// BGM̍Đ
		elDraw::Clear();
		for ( x = 0; x < 10; x++ )
		{
			for ( y = 0; y < 10; y++ )
			{
				i = rand()%9;
				elDraw::BrightLayer(x*32,y*32,0.5f,MapBMP[map],
					32*i,winner*32+32,32*i+32,winner*32+64);
			}
		}
		elDraw::SpriteScreen(ScreenBMP,0,0,320,320);
	}

	elDraw::TileLayer(16.0f,16.0f,ScreenBMP,0,0,320,320);

	elDraw::Layer((640-400)/2,100,WinnerBMP,0,0,400,102);
	elDraw::Layer((640-40)/2,300,CharaBMP,40,winner*60,80,winner*60+60);

	// tbV
	elDraw::Refresh();

	elSystem::GetKey(VK_RETURN,&KeyReturn);
	elSystem::GetKey(VK_SPACE,&KeySpace);
	elSystem::GetKey(VK_ESCAPE,&KeyEscape);

	if ( KeySpace==PUSH_KEY || KeyReturn==PUSH_KEY || KeyEscape==PUSH_KEY )
	{
		elFadeType(FADE_SLIDE_LEFTRIGHT,20);
		elFadeScreen(TITLE_SCREEN);
		elSound::Play(SelectWAV);
	}
}

/********************************************************************************/
/*                                                                              */
/*   FttHgTCYtHg^Cvo				                    */
/*                                                                              */
/********************************************************************************/

void ShowString2(long x,long y,char* Str,COLORREF color,short size)
{
	elFont::Begin(GOTHIC,size,0,TRUE,FALSE,FALSE);
	elFont::Color(color,0,TRUE);
	elFont::Draw(x, y, Str);
	elFont::Before();
}
